import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import '@guoyunhe/prism-theme-github/github-light.css';
import { MDXProvider } from '@mdx-js/react';
import cn from 'classnames';
import { createInstance } from 'i18next';
import LanguageDetector from 'i18next-browser-languagedetector';
import { useMemo } from 'react';
import { I18nextProvider } from 'react-i18next';
import { Route, Router, Switch } from 'wouter';
import './DocUI.css';
import { SiteNav } from './private/SiteNav.js';
import { components } from './private/components.js';
import { getRoutePath } from './private/getRoutePath.js';
export function DocUI({ docs = [], basename, languages, className, style, }) {
    const i18n = useMemo(() => {
        const i18n = createInstance({
            fallbackLng: 'en',
            supportedLngs: languages?.map((lang) => lang.code),
            debug: true,
            interpolation: {
                escapeValue: false, // not needed for react as it escapes by default
            },
            resources: {
                en: {
                    translation: {
                        copy: 'Copy',
                        success: 'Success',
                        phone: 'Phone',
                        tablet: 'Tablet',
                        laptop: 'Laptop',
                    },
                },
                zh: {
                    translation: {
                        copy: '复制',
                        success: '成功',
                        phone: '手机',
                        tablet: '平板电脑',
                        laptop: '笔记本',
                    },
                },
            },
        });
        i18n.use(LanguageDetector);
        i18n.init();
        return i18n;
    }, [languages]);
    return (_jsx(I18nextProvider, { i18n: i18n, children: _jsx("div", { className: cn('doc-ui', className), style: style, children: _jsxs(Router, { base: basename.replace(/\/+$/, ''), children: [_jsx(SiteNav, { languages: languages, docs: docs }), _jsx("main", { className: "doc-ui-main", children: _jsx("article", { className: "doc-ui-content", children: _jsx(MDXProvider, { components: components, children: _jsx(Switch, { children: docs.map((doc) => (_jsx(Route, { path: getRoutePath(doc.filepath), component: doc.default }, doc.filepath))) }) }) }) })] }) }) }));
}
