import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useEffect, useState } from 'react';
import { BiCopy } from 'react-bootstrap-icons-pro';
import { useTranslation } from 'react-i18next';
import { SuccessButton } from './SuccessButton.js';
import { ToolButton } from './ToolButton.js';
export function CopyButton({ code }) {
    const { t } = useTranslation();
    const [success, setSuccess] = useState(false);
    useEffect(() => {
        let timer = 0;
        if (success) {
            timer = window.setTimeout(() => {
                setSuccess(false);
            }, 1500);
        }
        return () => {
            window.clearTimeout(timer);
        };
    }, [success]);
    if (success) {
        return _jsx(SuccessButton, {});
    }
    return (_jsxs(ToolButton, { onClick: () => {
            navigator.clipboard
                .writeText(code || '')
                .then(() => {
                setSuccess(true);
            })
                .catch();
        }, children: [_jsx(BiCopy, {}), t('copy')] }));
}
