import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import cn from 'classnames';
import { useMemo, useState } from 'react';
import { BiLaptop, BiPhone, BiTablet } from 'react-bootstrap-icons-pro';
import { useTranslation } from 'react-i18next';
import { LiveEditor, LiveError, LivePreview, LiveProvider } from 'react-live';
import { CopyButton } from './CopyButton.js';
import './DemoBlock.css';
import { FileName } from './FileName.js';
import { Spacer } from './Spacer.js';
import { Toolbar } from './Toobar.js';
import { ToolButton } from './ToolButton.js';
import { ToolSelect } from './ToolSelect.js';
import { transformCode } from './transformCode.js';
export function DemoBlock({ code, filename, language = 'jsx', device = 'responsive', disablePadding, className, style, imports, }) {
    const { t } = useTranslation();
    const deviceList = useMemo(() => [
        { value: 'phone', label: t('phone'), icon: _jsx(BiPhone, {}) },
        { value: 'tablet', label: t('tablet'), icon: _jsx(BiTablet, {}) },
        { value: 'laptop', label: t('laptop'), icon: _jsx(BiLaptop, {}) },
    ], [t]);
    const [selectedDevice, setSelectedDevice] = useState(device === 'responsive' ? 'laptop' : device);
    const selectedDeviceObj = useMemo(() => deviceList.find((item) => item.value === selectedDevice), [selectedDevice, deviceList]);
    return (_jsxs("div", { className: cn('doc-ui-demo-block', 'doc-ui-demo-block-' + selectedDevice, className), style: style, children: [_jsxs(Toolbar, { children: [_jsx(FileName, { language: language, filename: filename }), _jsx(Spacer, {}), device === 'responsive' ? (_jsx(ToolSelect, { value: selectedDevice, onChange: setSelectedDevice, options: deviceList })) : (_jsx(ToolButton, { icon: selectedDeviceObj?.icon, children: selectedDeviceObj?.label })), _jsx(CopyButton, { code: code })] }), _jsx(LiveProvider, { code: code, 
                // disable the built-in theme of react-prism-renderer
                theme: { plain: {}, styles: [] }, enableTypeScript: language === 'tsx', transformCode: transformCode, scope: imports, noInline: code?.includes('render('), children: _jsxs("div", { className: "doc-ui-demo-block-main", children: [_jsx(LivePreview, { className: cn('doc-ui-demo-block-preview', disablePadding && 'doc-ui-demo-block-preview-disable-padding') }), _jsxs("div", { className: "doc-ui-demo-block-develop", children: [_jsx(LiveError, { className: "doc-ui-demo-block-error" }), _jsx(LiveEditor, { className: "doc-ui-demo-block-editor" })] })] }) })] }));
}
